
local love = love

function love.conf(t)
  t.console = true
end

local function printf(...)
	print(...)
	-- io.flush()
end

local t1, t2, t3, t4, t5, t6
function love.load()
    t1 = love.thread.newThread("thread_sleep.lua")
    t2 = love.thread.newThread("thread_sleep.lua")
    t3 = love.thread.newThread("thread.lua")
    t4 = love.thread.newThread("thread.lua")
    t5 = love.thread.newThread("thread_sleep.lua")
    t6 = love.thread.newThread("thread.lua")
    t1:start("1")
    t2:start("2")
    t3:start("3")
    t4:start("4")
    t5:start("5")
    t6:start("6")
end

local x, y = 0, 0
local results = {}
function love.update(dt)
    x = x + dt
    y = y + dt
    if y >= 1 then
        y = y - 1
        printf("gametime: "..math.floor(x))
    end

    do local error = t1:getError() assert(not error, error) end
    do local error = t2:getError() assert(not error, error) end
    do local error = t3:getError() assert(not error, error) end
    do local error = t4:getError() assert(not error, error) end
    do local error = t5:getError() assert(not error, error) end

    for _,i in ipairs({ "1", "2", "3" ,"4", "5", "6" }) do
        local msg = love.thread.getChannel("thread_"..i):pop()
        if msg then
            printf("main "..i..": "..tostring(msg))
            results[i] = msg
        end
    end
end

function love.draw()
    love.graphics.print("gametime: "..math.floor(x), 10, 10)
    love.graphics.print("thread sleep 1: "..tostring(results["1"]), 10, 30)
    love.graphics.print("thread sleep 2: "..tostring(results["2"]), 10, 50)
    love.graphics.print("thread 3: "..tostring(results["3"]), 10, 70)
    love.graphics.print("thread 4: "..tostring(results["4"]), 10, 90)
    love.graphics.print("thread sleep 5: "..tostring(results["5"]), 10, 110)
    love.graphics.print("thread 6: "..tostring(results["6"]), 10, 130)
end
